'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ExpandBoard = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _button = require('kitten/components/buttons/button');

var _arrowIcon = require('kitten/components/icons/arrow-icon');

var _colorsConfig = require('kitten/constants/colors-config');

var _colorsConfig2 = _interopRequireDefault(_colorsConfig);

var _typography = require('kitten/helpers/utils/typography');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Button = (0, _radium2.default)(_button.Button);

var ExpandBoardButton = function (_Component) {
  _inherits(ExpandBoardButton, _Component);

  function ExpandBoardButton() {
    _classCallCheck(this, ExpandBoardButton);

    return _possibleConstructorReturn(this, (ExpandBoardButton.__proto__ || Object.getPrototypeOf(ExpandBoardButton)).apply(this, arguments));
  }

  _createClass(ExpandBoardButton, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          expandChildren = _props.expandChildren,
          expanded = _props.expanded,
          disabled = _props.disabled,
          style = _props.style,
          onClick = _props.onClick,
          ariaId = _props.ariaId;

      var defaultExpandChildren = expandChildren ? expandChildren : children;
      var buttonStyles = expanded ? _extends({}, style.base, style.expanded) : style.base;

      return _react2.default.createElement(
        Button,
        {
          icon: true,
          iconOnRight: true,
          size: 'big',
          modifier: 'helium',
          disabled: disabled,
          'aria-expanded': expanded,
          'aria-controls': ariaId,
          style: buttonStyles,
          onClick: onClick,
          type: 'button'
        },
        expanded ? defaultExpandChildren : children,
        _react2.default.createElement(_arrowIcon.ArrowIcon, {
          direction: expanded ? 'top' : 'bottom',
          className: 'k-Button__icon',
          fill: _colorsConfig2.default.background1,
          style: style.arrow
        })
      );
    }
  }]);

  return ExpandBoardButton;
}(_react.Component);

ExpandBoardButton.propTypes = {
  children: _propTypes2.default.node.isRequired,
  ariaId: _propTypes2.default.string,
  expandChildren: _propTypes2.default.node,
  expanded: _propTypes2.default.bool,
  disabled: _propTypes2.default.bool,
  style: _propTypes2.default.object,
  onClick: _propTypes2.default.func
};
ExpandBoardButton.defaultProps = {
  expandChildren: null,
  expanded: false,
  disabled: false,
  style: {},
  onClick: function onClick() {},
  ariaId: ''
};

var ExpandBoardContent = function (_Component2) {
  _inherits(ExpandBoardContent, _Component2);

  function ExpandBoardContent() {
    _classCallCheck(this, ExpandBoardContent);

    return _possibleConstructorReturn(this, (ExpandBoardContent.__proto__ || Object.getPrototypeOf(ExpandBoardContent)).apply(this, arguments));
  }

  _createClass(ExpandBoardContent, [{
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          children = _props2.children,
          ariaId = _props2.ariaId;


      return _react2.default.createElement(
        'div',
        { id: ariaId },
        children
      );
    }
  }]);

  return ExpandBoardContent;
}(_react.Component);

ExpandBoardContent.propTypes = {
  children: _propTypes2.default.node.isRequired,
  ariaId: _propTypes2.default.string
};
ExpandBoardContent.defaultProps = {
  ariaId: ''
};

var ExpandBoardBase = function (_Component3) {
  _inherits(ExpandBoardBase, _Component3);

  function ExpandBoardBase(props) {
    _classCallCheck(this, ExpandBoardBase);

    var _this3 = _possibleConstructorReturn(this, (ExpandBoardBase.__proto__ || Object.getPrototypeOf(ExpandBoardBase)).call(this));

    _this3.isButtonComponent = function (component) {
      return component.type === ExpandBoardButton;
    };

    _this3.isContentComponent = function (component) {
      return component.type === ExpandBoardContent;
    };

    _this3.handleClick = function () {
      _this3.setState(function (prevState) {
        return {
          expanded: !prevState.expanded
        };
      }, function () {
        document.activeElement.blur();
        _this3.props.onClick({ expanded: _this3.state.expanded });
      });
    };

    _this3.state = {
      expanded: false
    };
    return _this3;
  }

  _createClass(ExpandBoardBase, [{
    key: 'render',
    value: function render() {
      var _this4 = this;

      var _props3 = this.props,
          children = _props3.children,
          style = _props3.style,
          disabled = _props3.disabled,
          ariaId = _props3.ariaId;


      var button = null;
      var content = null;

      _react2.default.Children.forEach(children, function (child) {
        if (!_react2.default.isValidElement(child)) return null;

        if (_this4.isButtonComponent(child)) {
          button = _react2.default.cloneElement(child, {
            disabled: disabled,
            expanded: _this4.state.expanded,
            onClick: _this4.handleClick,
            style: styles.button,
            ariaId: ariaId
          });
        }

        if (_this4.isContentComponent(child)) {
          content = _react2.default.cloneElement(child, {
            ariaId: ariaId
          });
        }
      });

      return _react2.default.createElement(
        'div',
        { style: style },
        button,
        this.state.expanded && content
      );
    }
  }]);

  return ExpandBoardBase;
}(_react.Component);

ExpandBoardBase.Button = ExpandBoardButton;
ExpandBoardBase.Content = ExpandBoardContent;
ExpandBoardBase.propTypes = {
  children: _propTypes2.default.node.isRequired,
  disabled: _propTypes2.default.bool,
  style: _propTypes2.default.object,
  onClick: _propTypes2.default.func,
  ariaId: _propTypes2.default.string.isRequired
};
ExpandBoardBase.defaultProps = {
  disabled: false,
  style: {},
  onClick: function onClick() {},
  ariaId: 'k-ExpandBoard'
};


var styles = {
  button: {
    base: {
      width: '100%',
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center',
      lineHeight: '1.3em',
      // As the arrow takes a huge space because of its rotation, we cannot
      // apply the same paddings as on the basic big button. These values ajust
      // the paddings so it fits the same as the basic big button.
      paddingTop: (0, _typography.pxToRem)(3),
      paddingBottom: (0, _typography.pxToRem)(3)
    },
    expanded: {
      backgroundColor: _colorsConfig2.default.font1,
      borderColor: _colorsConfig2.default.font1
    },
    arrow: {
      width: '0.375rem',
      height: '0.375rem'
    }
  }
};

var ExpandBoard = exports.ExpandBoard = (0, _radium2.default)(ExpandBoardBase);