'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.List = exports.ListBase = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _radium = require('radium');

var _radium2 = _interopRequireDefault(_radium);

var _arrowIcon = require('kitten/components/icons/arrow-icon');

var _colorsConfig = require('kitten/constants/colors-config');

var _colorsConfig2 = _interopRequireDefault(_colorsConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var ListButtonItem = function ListButtonItem(_ref) {
  var children = _ref.children,
      disabled = _ref.disabled,
      style = _ref.style,
      onClick = _ref.onClick,
      withTopBorder = _ref.withTopBorder,
      others = _objectWithoutProperties(_ref, ['children', 'disabled', 'style', 'onClick', 'withTopBorder']);

  var buttonStyles = [styles.buttonItem.base, style, withTopBorder && styles.buttonItem.topBorder, disabled && styles.buttonItem.disabled];

  var handleKeyPress = function handleKeyPress(event) {
    var enterKey = 13;
    var spaceKey = 32;

    switch (event.which) {
      case enterKey:
      case spaceKey:
        event.preventDefault;
        onClick();
        break;
    }
  };

  return _react2.default.createElement(
    _radium.StyleRoot,
    null,
    _react2.default.createElement(
      'div',
      _extends({}, others, {
        role: 'button',
        style: buttonStyles,
        tabIndex: '0',
        onClick: disabled ? null : onClick,
        onKeyPress: disabled ? null : handleKeyPress
      }),
      _react2.default.createElement(
        'div',
        { style: styles.buttonItem.content },
        children
      ),
      _react2.default.createElement(
        'div',
        { style: styles.buttonItem.arrow },
        _react2.default.createElement(_arrowIcon.ArrowIcon, {
          className: 'k-Button__icon',
          style: disabled ? styles.buttonItem.icon.disabled : null
        })
      )
    )
  );
};

ListButtonItem.propTypes = {
  children: _propTypes2.default.node.isRequired,
  disabled: _propTypes2.default.bool,
  style: _propTypes2.default.object,
  onClick: _propTypes2.default.func,
  withTopBorder: _propTypes2.default.bool
};

ListButtonItem.defaultProps = {
  disabled: false,
  style: {},
  onClick: function onClick() {},
  withTopBorder: false
};

var ListBase = exports.ListBase = function (_Component) {
  _inherits(ListBase, _Component);

  function ListBase() {
    _classCallCheck(this, ListBase);

    return _possibleConstructorReturn(this, (ListBase.__proto__ || Object.getPrototypeOf(ListBase)).apply(this, arguments));
  }

  _createClass(ListBase, [{
    key: 'render',
    value: function render() {
      var children = this.props.children;


      return _react2.default.createElement(
        'ul',
        { style: styles.list },
        _react2.default.Children.map(children, function (child, index) {
          if (!_react2.default.isValidElement(child)) return null;

          return _react2.default.createElement(
            'li',
            null,
            child
          );
        })
      );
    }
  }]);

  return ListBase;
}(_react.Component);

ListBase.ButtonItem = ListButtonItem;


ListBase.propTypes = {
  children: _propTypes2.default.node.isRequired
};

var styles = {
  list: {
    listStyle: 'none',
    margin: 0,
    padding: 0
  },
  buttonItem: {
    base: {
      display: 'flex',
      borderLeft: _colorsConfig2.default.line1 + ' 0.125rem solid',
      borderRight: _colorsConfig2.default.line1 + ' 0.125rem solid',
      borderBottom: _colorsConfig2.default.line1 + ' 0.125rem solid',
      cursor: 'pointer',
      paddingLeft: '1.25rem',
      paddingRight: '1.25rem',
      ':hover': {
        backgroundColor: _colorsConfig2.default.background2
      }
    },
    topBorder: {
      borderTop: _colorsConfig2.default.line1 + ' 0.125rem solid'
    },
    disabled: {
      color: _colorsConfig2.default.line2,
      backgroundColor: _colorsConfig2.default.background1,
      cursor: 'not-allowed',
      ':hover': {
        backgroundColor: _colorsConfig2.default.background1
      }
    },
    content: {
      flexGrow: 1
    },
    arrow: {
      display: 'flex',
      alignItems: 'center'
    },
    icon: {
      disabled: {
        fill: _colorsConfig2.default.line2
      }
    }
  }
};

var List = exports.List = (0, _radium2.default)(ListBase);